{ This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  ---------------------------------------------------------------------------

    Basic SQL Parser
    Author : Luc DAVID Email: luckylazarus@free.fr
    2007 - 2008

    Major changes are indicated in the \Documentation\changes.pdf file
    Last update : 31.05.2008

  --------------------------------------------------------------------------- }


unit SqlitePassKexiDef;
{$i SqlitePassDbo.inc}

interface

Const

{ ----- Special declarations for Kexi ----- }

{ Kexi system tables }
KexiSystemTables:array[0..7] of string =
           ('kexi__db',
            'kexi__fields',
            'kexi__final',
            'kexi__objects',
            'kexi__objectdata',
            'kexi__parts',
            'kexi__useractions',
            'kexi__blobs');

{ Kexi field constraints info }
   (*
   NoConstraints = 0,
   AutoInc = 1, ?
   Unique = 2,  ?
   PrimaryKey = 4, ?
   ForeignKey = 8, -> FieldType
   NotNull = 16,   ?
   NotEmpty = 32, ? //!< only legal for string-like and blob fields
   Indexed = 64 -> IsIndexField
   *)

KexiFieldConstraints = 'NoConstraints,AutoInc,Unique,PrimaryKey,ForeignKey,NotNull,NotEmpty,Indexed';

{ SQL Stqtements used to create system tables needed by Kexi (used by TSqlitePassDatabase.CreateDatabase) }
KexiDb_CreateSQLStmt = 'CREATE TABLE kexi__db (db_property Text(32), db_value CLOB);';
KexiParts_CreateSQLStmt = 'CREATE TABLE kexi__parts (p_id INTEGER PRIMARY KEY, p_name Text(200), p_mime Text(200), p_url Text(200));';
KexiObjects_CreateSQLStmt = 'CREATE TABLE kexi__objects (o_id INTEGER PRIMARY KEY, o_type Byte UNSIGNED, o_name Text(200), o_caption Text(200), o_desc CLOB);';
KexiObjectData_CreateSQLStmt = 'CREATE TABLE kexi__objectdata (o_id Integer UNSIGNED NOT NULL, o_data CLOB, o_sub_id Text(200));';
KexiFields_CreateSQLStmt = 'CREATE TABLE kexi__fields (t_id Integer UNSIGNED, f_type Byte UNSIGNED, f_name Text(200), f_length Integer, f_precision Integer, f_constraints Integer, f_options Integer, f_default Text(200), f_order Integer, f_caption Text(200), f_help CLOB);';
KexiBlobs_CreateSQLStmt = 'CREATE TABLE kexi__blobs (o_id INTEGER PRIMARY KEY, o_data BLOB, o_name Text(200), o_caption Text(200), o_mime Text(200) NOT NULL, o_folder_id Integer UNSIGNED);';
implementation
end.

