{**************************************************************************************************}
{                                                                                                  }
{ UTF-8 VCL                                                                                        }
{                                                                                                  }
{ The contents of this file are subject to the Mozilla Public License Version 1.1 (the "License"); }
{ you may not use this file except in compliance with the License. You may obtain a copy of the    }
{ License at http://www.mozilla.org/MPL/                                                           }
{                                                                                                  }
{ Software distributed under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF   }
{ ANY KIND, either express or implied. See the License for the specific language governing rights  }
{ and limitations under the License.                                                               }
{                                                                                                  }
{ The Original Code is UTF8VCL.pas                                                                 }
{                                                                                                  }
{ The Initial Developer of the Original Code is Bart van der Werf (bwerf, bluelive)                }
{ Portions created by Bart van der Werf are Copyright (C) Bart van der Werf. All rights reserved.  }
{                                                                                                  }
{ Contributor(s):                                                                                  }
{   Andreas Hausladen (ahuser)                                                                     }
{   Robert Marquardt (rom, marquardt)                                                              }
{                                                                                                  }
{**************************************************************************************************}

// Last modified: $Date: 2007/04/03 12:23:20 $

unit UTF8VCL;

{$IFDEF CONDITIONALEXPRESSIONS}
 {$IF CompilerVersion >= 15.0}
  {$WARN UNSAFE_TYPE OFF}
  {$WARN UNSAFE_CODE OFF}
  {$WARN UNSAFE_CAST OFF}
 {$IFEND}
{$ENDIF}

interface

uses
  Windows, CommDlg;

procedure ActivateUtf8VCL(Active: Boolean);

type
  TMultiByteToWideChar = function(CodePage: UINT; dwFlags: DWORD;
    const lpMultiByteStr: LPCSTR; cchMultiByte: Integer;
    lpWideCharStr: LPWSTR; cchWideChar: Integer): Integer; stdcall;
  TWideCharToMultiByte = function(CodePage: UINT; dwFlags: DWORD;
    lpWideCharStr: LPWSTR; cchWideChar: Integer; lpMultiByteStr: LPSTR;
    cchMultiByte: Integer; lpDefaultChar: LPCSTR; lpUsedDefaultChar: PBOOL): Integer; stdcall;
  TGetACP = function: UINT; stdcall;
  TSendMessageA = function(hWnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
  TPostMessageA = function(hWnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): BOOL; stdcall;
  TCreateWindowExA = function(dwExStyle: DWORD; lpClassName: PAnsiChar;
    lpWindowName: PAnsiChar; dwStyle: DWORD; X, Y, nWidth, nHeight: Integer;
    hWndParent: HWND; hMenu: HMENU; hInstance: HINST; lpParam: Pointer): HWND; stdcall;
  TUnregisterClassA = function(lpClassName: PAnsiChar; hInstance: HINST): BOOL; stdcall;
  TRegisterClassA = function(const lpWndClass: TWndClassA): ATOM; stdcall;
  TRegisterClassExA = function(const WndClass: TWndClassExA): ATOM; stdcall;
  TDrawTextA = function(hDC: HDC; lpString: PAnsiChar; nCount: Integer;
    var lpRect: TRect; uFormat: UINT): Integer; stdcall;
  TDrawTextExA = function(DC: HDC; lpchText: PAnsiChar; cchText: Integer; var p4: TRect;
    dwDTFormat: UINT; DTParams: PDrawTextParams): Integer; stdcall;
  TSetWindowLongA = function(hWnd: HWND; nIndex: Integer; dwNewLong: Longint): Longint; stdcall;
  TSetWindowTextA = function(hWnd: HWND; lpString: PAnsiChar): BOOL; stdcall;
  TGetClassInfoA = function(hInstance: HINST; lpClassName: PAnsiChar;
    var lpWndClass: TWndClassA): BOOL; stdcall;
  TGetClassInfoExA = function(Instance: HINST; Classname: PAnsiChar; var WndClass: TWndClassExA): BOOL; stdcall;
  TCallWindowProcA = function(lpPrevWndFunc: TFNWndProc; hWnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
  TIsWindowUnicode = function(hWnd: HWND): BOOL; stdcall;
  TGetWindowLongA = function(hWnd: HWND; nIndex: Integer): Longint; stdcall;
  TDefWindowProcA = function(hWnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
  TDefMDIChildProcA = function(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
  TDefDlgProcA = function(hDlg: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
  TGetWindowTextA = function(hWnd: HWND; lpString: PAnsiChar; nMaxCount: Integer): Integer; stdcall;
  TInsertMenuA = function(hMenu: HMENU; uPosition, uFlags, uIDNewItem: UINT;
    lpNewItem: PAnsiChar): BOOL; stdcall;
  TInsertMenuItemA = function(p1: HMENU; p2: UINT; p3: BOOL; const p4: TMenuItemInfoA): BOOL; stdcall;
  TMessageBoxA = function(hWnd: HWND; lpText, lpCaption: PAnsiChar; uType: UINT): Integer; stdcall;
  TTextOutA = function(DC: HDC; X, Y: Integer; Str: PAnsiChar; Count: Integer): BOOL; stdcall;
  TExtTextOutA = function(DC: HDC; X, Y: Integer; Options: Longint;
    Rect: PRect; Str: PAnsiChar; Count: Longint; Dx: PInteger): BOOL; stdcall;
  TGetTextExtentPoint32A = function(DC: HDC; Str: PAnsiChar; Count: Integer;
    var Size: TSize): BOOL; stdcall;
  TGetTextExtentPointA = function(DC: HDC; Str: PAnsiChar; Count: Integer; var Size: TSize): BOOL; stdcall;
  TGetTextExtentExPointA = function(DC: HDC; p2: PAnsiChar;
    p3, p4: Integer; p5, p6: PInteger; var p7: TSize): BOOL; stdcall;
  TOutputDebugStringA = procedure(lpOutputString: PAnsiChar); stdcall;
  TFatalAppExitA = procedure(uAction: UINT; lpMessageText: PAnsiChar); stdcall;
  TGetOpenFileNameA = function(var OpenFile: TOpenFilenameA): Bool; stdcall;
  TGetSaveFileNameA = function(var OpenFile: TOpenFilenameA): Bool; stdcall;
  TGetFileTitleA = function(FileName: PAnsiChar; Title: PAnsiChar; TitleSize: Word): Smallint; stdcall;
  TChooseColorAProc = function(var CC: TChooseColorA): Bool; stdcall;
  TDefFrameProcA = function(hWnd: HWND; hChldWnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

var
  NonUTF8MultiByteToWideChar: TMultiByteToWideChar;
  NonUTF8WideCharToMultiByte: TWideCharToMultiByte;
  NonUTF8GetACP: TGetACP;

  NonUTF8SendMessage: TSendMessageA;
  NonUTF8PostMessage: TPostMessageA;
  NonUTF8CreateWindowEx: TCreateWindowExA;
  NonUTF8UnregisterClass: TUnregisterClassA;
  NonUTF8RegisterClass: TRegisterClassA;
  NonUTF8RegisterClassEx: TRegisterClassExA;
  NonUTF8DrawText: TDrawTextA;
  NonUTF8DrawTextEx: TDrawTextExA;
  NonUTF8SetWindowLong: TSetWindowLongA;
  NonUTF8SetWindowText: TSetWindowTextA;
  NonUTF8GetClassInfo: TGetClassInfoA;
  NonUTF8GetClassInfoEx: TGetClassInfoExA;
  NonUTF8CallWindowProc: TCallWindowProcA;
  NonUTF8IsWindowUnicode: TIsWindowUnicode;
  NonUTF8GetWindowLong: TGetWindowLongA;

  NonUTF8DefWindowProc: TDefWindowProcA;
  NonUTF8DefMDIChildProc: TDefMDIChildProcA;
  NonUTF8DefDlgProc: TDefDlgProcA;

  NonUTF8GetWindowText: TGetWindowTextA;
  NonUTF8InsertMenu: TInsertMenuA;
  NonUTF8InsertMenuItem: TInsertMenuItemA;
  NonUTF8MessageBox: TMessageBoxA;

  NonUTF8TextOut: TTextOutA;
  NonUTF8ExtTextOut: TExtTextOutA;
  NonUTF8GetTextExtentPoint32: TGetTextExtentPoint32A;
  NonUTF8GetTextExtentPoint: TGetTextExtentPointA;
  NonUTF8GetTextExtentExPoint: TGetTextExtentExPointA;

  NonUTF8OutputDebugString: TOutputDebugStringA;
  NonUTF8FatalAppExit: TFatalAppExitA;

  NonUTF8GetOpenFileName: TGetOpenFileNameA;
  NonUTF8GetSaveFileName: TGetSaveFileNameA;
  NonUTF8GetFileTitle: TGetFileTitleA;
  NonUTF8ChooseColor: TChooseColorAProc;

  NonUTF8DefFrameProc: TDefFrameProcA;

  NonUTF8DefaultSystemCodePage: Integer;

implementation

uses
  Messages, SysUtils, Classes,
  UTF8VCLUtils, UTF8VCLMessages, UTF8VCLCommDlg;

const
  // not available in all Delphi versions (taken from JwaWinNLS.pas)
  CP_THREAD_ACP = 3; // current thread's ANSI code page

function _CreateWindowExW(dwExStyle: DWORD; lpClassName: PWideChar;
  lpWindowName: PWideChar; dwStyle: DWORD; X, Y, nWidth, nHeight: Integer;
  hWndParent: HWND; hMenu: HMENU; hInstance: HINST; lpParam: Pointer): HWND;
  stdcall; external user32 name 'CreateWindowExW';

function SendMessageAIntercept(hWnd: HWND; Msg: UINT; WParam: WPARAM; LParam: LPARAM): LRESULT; stdcall;
var
  TempWParam, TempLParam: Longint;
begin
  MessageU2WBefore(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, Pointer(@SendMessageW), nil);
  Result := SendMessageW(hWnd, Msg, TempWParam, TempLParam);
  Result := MessageU2WAfter(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, Result, Pointer(@SendMessageW), nil);
end;

function PostMessageAIntercept(hWnd: HWND; Msg: UINT; WParam: WPARAM; LParam: LPARAM): BOOL; stdcall;
var
  TempWParam, TempLParam: Longint;
begin
  MessageU2WBefore(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, Pointer(@PostMessageW), nil);
  Result := PostMessageW(hWnd, Msg, TempWParam, TempLParam);
  MessageU2WAfter(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, 0, Pointer(@PostMessageW), nil);
end;

{ToWindows}

function CallWindowProcAIntercept(lpPrevWndFunc: TFNWndProc; hWnd: HWND; Msg: UINT;
  WParam: WPARAM; LParam: LPARAM): LRESULT; stdcall;
var
  TempWParam, TempLParam: Longint;
  Proc: Pointer;
begin
  TStdWndProcDef(Proc) := WndProcConvertW2U(lpPrevWndFunc, StdWndProcInterceptU2W, StdWndProcInterceptW2U);

  MessageU2WBefore(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, TStdWndProcDef(Proc), nil);
  Result := CallWindowProcW(Proc, hWnd, Msg, TempWParam, TempLParam);
  Result := MessageU2WAfter(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, Result, TStdWndProcDef(Proc), nil);
end;

function CreateWindowExAIntercept(dwExStyle: DWORD; lpClassName: PAnsiChar; lpWindowName: PAnsiChar; dwStyle: DWORD;
  X, Y, nWidth, nHeight: Integer; hWndParent: HWND; hMenu: HMENU; hInstance: HINST; lpParam: Pointer): HWND; stdcall;
var
  lpwClassName: PWideChar;
  lpwWindowName: PWideChar;
begin
  lpwClassName := nil;
  lpwWindowName := nil;
  try
    lpwClassName := ConvertFromUTF8(lpClassName);
    lpwWindowName := ConvertFromUTF8(lpWindowName);
    Result := _CreateWindowExW(dwExStyle, lpwClassName, lpwWindowName, dwStyle, X, Y, nWidth, nHeight,
      hWndParent, hMenu, hInstance, lpParam);
  finally
    FreeMem(lpwWindowName);
    FreeMem(lpwClassName);
  end;
end;

function UnregisterClassAIntercept(lpClassName: PAnsiChar; hInstance: HINST): BOOL; stdcall;
var
  lpwClassName: PWideChar;
begin
  lpwClassName := ConvertFromUTF8(lpClassName);
  try
    Result := Windows.UnregisterClassW(lpwClassName, hInstance);
  finally
    FreeMem(lpwClassName);
  end;
end;

function RegisterClassAIntercept(const WndClassA: TWndClassA): ATOM; stdcall;
var
  WndClassW: TWndClassW;
begin
  Move(WndClassA, WndClassW, SizeOf(TWndClassA));
  WndClassW.lpszMenuName := nil;
  WndClassW.lpszClassName := nil;
  try
    WndClassW.lpfnWndProc := WndProcConvertW2U(WndClassA.lpfnWndProc,
      Pointer(@StdWndProcInterceptU2W), Pointer(@StdWndProcInterceptW2U));
    WndClassW.lpszMenuName := ConvertFromUTF8(WndClassA.lpszMenuName);
    WndClassW.lpszClassName := ConvertFromUTF8(WndClassA.lpszClassName);
    Result := Windows.RegisterClassW(WndClassW);
  finally
    FreeMem(WndClassW.lpszMenuName);
    FreeMem(WndClassW.lpszClassName);
  end;
end;

function RegisterClassExAIntercept(const WndClassA: TWndClassExA): ATOM; stdcall;
var
  WndClassW: TWndClassExW;
begin
  Move(WndClassA, WndClassW, SizeOf(TWndClassExA));
  WndClassW.lpszMenuName := nil;
  WndClassW.lpszClassName := nil;
  try
    WndClassW.lpfnWndProc := WndProcConvertW2U(WndClassA.lpfnWndProc,
      Pointer(@StdWndProcInterceptU2W), Pointer(@StdWndProcInterceptW2U));
    WndClassW.lpszMenuName := ConvertFromUTF8(WndClassA.lpszMenuName);
    WndClassW.lpszClassName := ConvertFromUTF8(WndClassA.lpszClassName);
    Result := RegisterClassExW(WndClassW);
  finally
    FreeMem(WndClassW.lpszMenuName);
    FreeMem(WndClassW.lpszClassName);
  end;
end;

function DrawTextAIntercept(hDC: HDC; lpString: PAnsiChar; nCount: Integer; var lpRect: TRect;
  uFormat: UINT): Integer; stdcall;
var
  C: PWideChar;
  L: Integer;
begin
  C := ConvertFromUTF8(lpString, nCount, L);
  try
    Result := DrawTextW(hDC, C, L, lpRect, uFormat);
  finally
    FreeMem(C);
  end;
end;

function DrawTextExAIntercept(DC: HDC; lpchText: PAnsiChar; cchText: Integer; var p4: TRect; dwDTFormat: UINT;
  DTParams: PDrawTextParams): Integer; stdcall;
var
  C: PWideChar;
  L: Integer;
begin
  C := ConvertFromUTF8(lpchText, cchText, L);
  try
    Result := DrawTextExW(DC, C, L, p4, dwDTFormat, DTParams);
  finally
    FreeMem(C);
  end;
end;

function TextOutAIntercept(DC: HDC; X, Y: Integer; Str: PAnsiChar; Count: Integer): BOOL; stdcall;
var
  C: PWideChar;
  L: Integer;
begin
  C := ConvertFromUTF8(Str, Count, L);
  try
    Result := TextOutW(DC, X, Y, C, L);
  finally
    FreeMem(C);
  end;
end;

function ExtTextOutAIntercept(DC: HDC; X, Y: Integer; Options: Longint;
  Rect: PRect; Str: PAnsiChar; Count: Longint; Dx: PInteger): BOOL; stdcall;
var
  C: PWideChar;
  L: Integer;
begin
  C := ConvertFromUTF8(Str, Count, L);
  try
    Result := ExtTextOutW(DC, X, Y, Options, Rect, C, L, Dx);
  finally
    FreeMem(C);
  end;
end;

function GetTextExtentPoint32AIntercept(DC: HDC; Str: PAnsiChar; Count: Integer; var Size: TSize): BOOL; stdcall;
var
  C: PWideChar;
  L: Integer;
begin
  C := ConvertFromUTF8(Str, Count, L);
  try
    Result := GetTextExtentPoint32W(DC, C, L, Size);
  finally
    FreeMem(C);
  end;
end;

function GetTextExtentPointAIntercept(DC: HDC; Str: PAnsiChar; Count: Integer; var Size: TSize): BOOL; stdcall;
var
  C: PWideChar;
  L: Integer;
begin
  C := ConvertFromUTF8(Str, Count, L);
  try
    Result := GetTextExtentPointW(DC, C, L, Size);
  finally
    FreeMem(C);
  end;
end;

function GetTextExtentExPointAIntercept(DC: HDC; Str: PAnsiChar; Count, nMaxExtent: Integer;
  lpnFit, alpDx: PInteger; var lpSize: TSize): BOOL; stdcall;
var
  C: PWideChar;
  L: Integer;
begin
  C := ConvertFromUTF8(Str, Count, L);
  try
    Result := GetTextExtentExPointW(DC, C, L, nMaxExtent, lpnFit, alpDx, lpSize);
  finally
    FreeMem(C);
  end;
end;

function SetWindowLongAIntercept(hWnd: HWND; nIndex: Integer; dwNewLong: Longint): Longint; stdcall;
var
  Proc: Pointer;
begin
  if (nIndex = GWL_WNDPROC) or (nIndex = DWL_DLGPROC) then
  begin
    Proc := WndProcConvertW2U(Pointer(dwNewLong),
      Pointer(@StdWndProcInterceptU2W), Pointer(@StdWndProcInterceptW2U));
    Proc := Pointer(SetWindowLongW(hWnd, nIndex, Integer(Proc)));
    Result := Integer(WndProcConvertU2W(Pointer(Proc),
      Pointer(@StdWndProcInterceptU2W), Pointer(@StdWndProcInterceptW2U)));
  end
  else
    Result := SetWindowLongW(hWnd, nIndex, dwNewLong);
end;

function GetWindowLongAIntercept(hWnd: HWND; nIndex: Integer): Longint; stdcall;
begin
  if (nIndex = GWL_WNDPROC) or (nIndex = DWL_DLGPROC) then
  begin
    Result := GetWindowLongW(hWnd, nIndex);
    Pointer(Result) := WndProcConvertU2W(Pointer(Result),
      Pointer(@StdWndProcInterceptU2W), Pointer(@StdWndProcInterceptW2U));
    SetWindowLongAIntercept(hWnd, nIndex, Result);
  end
  else
    Result := GetWindowLongW(hWnd, nIndex);
end;

function SetWindowTextAIntercept(hWnd: HWND; lpString: PAnsiChar): BOOL; stdcall;
var
  C: PWideChar;
begin
  C := ConvertFromUTF8(lpString);
  try
    Result := SetWindowTextW(hWnd, C);
  finally
    FreeMem(C);
  end;
end;

function GetClassInfoAIntercept(hInstance: HINST; lpClassName: PAnsiChar; var WndClassA: TWndClassA): BOOL; stdcall;
var
  C: PWideChar;
  WndClassW: TWndClassW;
begin
  if (Cardinal(lpClassName) and $FFFF0000) <> 0 then
    C := ConvertFromUTF8(lpClassName)
  else
    // This isn't a string but a special id
    C := PWideChar(lpClassName);
  try
    FillChar(WndClassW, SizeOf(WndClassW), 0);
    Result := GetClassInfoW(hInstance, C, WndClassW);
    if Result then
    begin
      Move(WndClassW, WndClassA, SizeOf(TWndClassA));
      WndClassA.lpszMenuName := ConvertToUTF8(WndClassW.lpszMenuName);
      WndClassA.lpszClassName := ConvertToUTF8(WndClassW.lpszClassName);
      WndClassA.lpfnWndProc := WndProcConvertU2W(WndClassW.lpfnWndProc,
        Pointer(@StdWndProcInterceptU2W), Pointer(@StdWndProcInterceptW2U));
    end;
  finally
    if PWideChar(lpClassName) <> c then
      FreeMem(c);
  end;
end;

function GetClassInfoExAIntercept(Instance: HINST; ClassName: PAnsiChar; var WndClassA: TWndClassExA): BOOL; stdcall;
var
  C: PWideChar;
  WndClassW: TWndClassExW;
begin
  if (Cardinal(ClassName) and $FFFF0000) <> 0 then
    C := ConvertFromUTF8(ClassName)
  else
    // This isn't a string but a special id
    C := PWideChar(ClassName);
  try
    FillChar(WndClassW, SizeOf(WndClassW), 0);
    Result := GetClassInfoExW(Instance, C, WndClassW);
    if Result then
    begin
      Move(WndClassW, WndClassA, SizeOf(TWndClassA));
      WndClassA.lpszMenuName := ConvertToUTF8(WndClassW.lpszMenuName);
      WndClassA.lpszClassName := ConvertToUTF8(WndClassW.lpszClassName);
      WndClassA.lpfnWndProc := WndProcConvertU2W(WndClassW.lpfnWndProc,
        Pointer(@StdWndProcInterceptU2W), Pointer(@StdWndProcInterceptW2U));
    end;
  finally
    if PWideChar(ClassName) <> C then
      FreeMem(C);
  end;
end;

function IsWindowUnicodeIntercept(hWnd: HWND): BOOL; stdcall;
begin
  Result := False;
end;

function DefWindowProcAIntercept(hWnd: HWND; Msg: UINT; WParam: WPARAM; LParam: LPARAM): LRESULT; stdcall;
var
  TempWParam, TempLParam: Longint;
begin
  MessageU2WBefore(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, Pointer(@DefWindowProcW), nil);
  Result := DefWindowProcW(hWnd, Msg, TempWParam, TempLParam);
  Result := MessageU2WAfter(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, Result, Pointer(@DefWindowProcW), nil);
end;

function DefMDIChildProcAIntercept(hWnd: HWND; Msg: UINT; WParam: WPARAM; LParam: LPARAM): LRESULT; stdcall;
var
  TempWParam, TempLParam: Longint;
begin
  MessageU2WBefore(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, Pointer(@DefMDIChildProcW), nil);
  Result := DefMDIChildProcW(hWnd, Msg, TempWParam, TempLParam);
  Result := MessageU2WAfter(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, Result, Pointer(@DefMDIChildProcW), nil);
end;

function DefDlgProcAIntercept(hWnd: HWND; Msg: UINT; WParam: WPARAM; LParam: LPARAM): LRESULT; stdcall;
var
  TempWParam, TempLParam: Longint;
begin
  MessageU2WBefore(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, Pointer(@DefDlgProcW), nil);
  Result := DefDlgProcW(hWnd, Msg, TempWParam, TempLParam);
  Result := MessageU2WAfter(hWnd, 0, Msg, WParam, LParam, TempWParam, TempLParam, Result, Pointer(@DefDlgProcW), nil);
end;

function GetWindowTextAIntercept(hWnd: HWND; lpString: PAnsiChar; nMaxCount: Integer): Integer; stdcall;
var
  C: PWideChar;
  L: Integer;
  X: PUtf8Char;
begin
  L := nMaxCount;
  if nMaxCount > 0 then
  begin
    X := nil;
    GetMem(C, SizeOf(WideChar) * L);
    try
      nMaxCount := GetWindowTextW(hWnd, C, L);
      X := ConvertToUTF8(C, nMaxCount, Result);
      if Result > 0 then
      begin
        Inc(Result);
        if Result > L then
          Result := L;
        Move(X^, lpString^, Result);
        Dec(Result);
      end;
    finally
      FreeMem(C);
      FreeMem(X);
    end;
  end
  else
    Result := 0;
end;

function InsertMenuAIntercept(hMenu: HMENU; uPosition, uFlags, uIDNewItem: UINT; lpNewItem: PAnsiChar): BOOL; stdcall;
var
  C: PWideChar;
begin
  C := ConvertFromUTF8(lpNewItem);
  try
    Result := InsertMenuW(hMenu, uPosition, uFlags, uIDNewItem, C);
  finally
    FreeMem(C);
  end;
end;

function InsertMenuItemAIntercept(hMenu: HMENU; uItem: UINT; fByPosition: BOOL;
  const lpmii: TMenuItemInfoA): BOOL; stdcall;
var
  lpmiiw: TMenuItemInfoW;
begin
  Move(lpmii, lpmiiw, SizeOf(TMenuItemInfoA));
  lpmiiw.dwTypeData := ConvertFromUTF8(lpmii.dwTypeData);
  try
    Result := InsertMenuItemW(hMenu, uItem, fByPosition, lpmiiw);
  finally
    FreeMem(lpmiiw.dwTypeData);
  end;
end;

function MessageBoxAIntercept(hWnd: HWND; lpText, lpCaption: PAnsiChar; uType: UINT): Integer; stdcall;
var
  Text, Caption: PWideChar;
begin
  Text := nil;
  Caption := nil;
  try
    Text := ConvertFromUTF8(lpText);
    Caption := ConvertFromUTF8(lpCaption);
    Result := MessageBoxW(hWnd, Text, Caption, uType);
  finally
    FreeMem(Caption);
    FreeMem(Text);
  end;
end;

procedure OutputDebugStringAIntercept(lpOutputString: PAnsiChar); stdcall;
var
  OutputString: PWideChar;
begin
  OutputString := nil;
  try
    OutputString := ConvertFromUTF8(lpOutputString);
    OutputDebugStringW(OutputString);
  finally
    FreeMem(OutputString);
  end;
end;

function MultiByteToWideCharIntercept(CodePage: UINT; dwFlags: DWORD;
  const lpMultiByteStr: LPCSTR; cchMultiByte: Integer;
  lpWideCharStr: LPWSTR; cchWideChar: Integer): Integer; stdcall;
begin
  if (CodePage = CP_ACP) or (CodePage = CP_THREAD_ACP) then
    CodePage := CP_UTF8;
  Result := NonUTF8MultiByteToWideChar(CodePage, dwFlags, lpMultiByteStr, cchMultiByte,
    lpWideCharStr, cchWideChar);
end;

function WideCharToMultiByteIntercept(CodePage: UINT; dwFlags: DWORD;
  lpWideCharStr: LPWSTR; cchWideChar: Integer; lpMultiByteStr: LPSTR;
  cchMultiByte: Integer; lpDefaultChar: LPCSTR; lpUsedDefaultChar: PBOOL): Integer; stdcall;
begin
  if (CodePage = CP_ACP) or (CodePage = CP_THREAD_ACP) then
    CodePage := CP_UTF8;
  Result := NonUTF8WideCharToMultiByte(CodePage, dwFlags, lpWideCharStr, cchWideChar, lpMultiByteStr,
    cchMultiByte, lpDefaultChar, lpUsedDefaultChar);
end;

procedure FatalAppExitAIntercept(uAction: UINT; lpMessageText: PAnsiChar); stdcall;
var
  MessageText: PWideChar;
begin
  MessageText := nil;
  try
    MessageText := ConvertFromUTF8(lpMessageText);
    FatalAppExitW(uAction, MessageText);
  finally
    FreeMem(MessageText);
  end;
end;

function GetACPIntercept: UINT; stdcall;
begin
  Result := CP_UTF8;
end;

function DefFrameProcAIntercept(hWnd: HWND; hChildWnd: HWND; Msg: UINT; WParam: WPARAM; LParam: LPARAM): LRESULT; stdcall;
var
  TempWParam, TempLParam: Longint;
begin
  MessageU2WBefore(hWnd, hChildWnd, Msg, WParam, LParam, TempWParam, TempLParam, nil, Pointer(@DefFrameProcW));
  Result := DefFrameProcW(hWnd, hChildWnd, Msg, TempWParam, TempLParam);
  Result := MessageU2WAfter(hWnd, hChildWnd, Msg, WParam, LParam, TempWParam, TempLParam, Result, nil, Pointer(@DefFrameProcW));
end;

//============================================================================

var
  ActiveState: Boolean = False;

  LibUser32: HMODULE = 0;
  LibGdi32: HMODULE = 0;
  LibKernel32: HMODULE = 0;
  LibCommdlg32: HMODULE = 0;

const
  commdlg32 = 'comdlg32.dll';

function HookFunc(const FunctionName: PChar; NewFunc: Pointer; var Module: HMODULE; const ModuleName: PChar): Pointer;
begin
  if Module = 0 then
    Module := GetModuleHandle(ModuleName);
  Result := GetProcAddress(Module, FunctionName);
  Assert(Result <> nil, Format('Function "%s" not found in %s', [FunctionName, ModuleName])); // must not be localized

  ReplaceImport(Pointer(HInstance), Result, NewFunc);
  //InjectJumpHook(Result, NewFunc); // no call to "Result" possible
end;

function HookUser32Func(const FunctionName: PChar; NewFunc: Pointer): Pointer;
begin
  Result := HookFunc(FunctionName, NewFunc, LibUser32, user32);
end;

function HookGdi32Func(const FunctionName: PChar; NewFunc: Pointer): Pointer;
begin
  Result := HookFunc(FunctionName, NewFunc, LibGdi32, gdi32);
end;

function HookKernel32Func(const FunctionName: PChar; NewFunc: Pointer): Pointer;
begin
  Result := HookFunc(FunctionName, NewFunc, LibKernel32, kernel32);
end;

function HookCommdlg32Func(const FunctionName: PChar; NewFunc: Pointer): Pointer;
begin
  Result := HookFunc(FunctionName, NewFunc, LibCommdlg32, commdlg32);
end;

procedure ActivateUtf8VCL(Active: Boolean);
begin
  if Active = ActiveState then
    Exit;
  if Active then
  begin
    NonUTF8MultiByteToWideChar := HookKernel32Func('MultiByteToWideChar', @MultiByteToWideCharIntercept); // do not localize
    NonUTF8WideCharToMultiByte := HookKernel32Func('WideCharToMultiByte', @WideCharToMultiByteIntercept); // do not localize
    NonUTF8GetACP := HookKernel32Func('GetACP', @GetACPIntercept); // do not localize

    NonUTF8SendMessage     := HookUser32Func('SendMessageA', @SendMessageAIntercept); // do not localize
    NonUTF8PostMessage     := HookUser32Func('PostMessageA', @PostMessageAIntercept); // do not localize
    NonUTF8CreateWindowEx  := HookUser32Func('CreateWindowExA', @CreateWindowExAIntercept); // do not localize
    NonUTF8UnregisterClass := HookUser32Func('UnregisterClassA', @UnregisterClassAIntercept); // do not localize
    NonUTF8RegisterClass   := HookUser32Func('RegisterClassA', @RegisterClassAIntercept); // do not localize
    NonUTF8RegisterClassEx := HookUser32Func('RegisterClassExA', @RegisterClassExAIntercept); // do not localize
    NonUTF8DrawText        := HookUser32Func('DrawTextA', @DrawTextAIntercept); // do not localize
    NonUTF8DrawTextEx      := HookUser32Func('DrawTextExA', @DrawTextExAIntercept); // do not localize
    NonUTF8SetWindowLong   := HookUser32Func('SetWindowLongA', @SetWindowLongAIntercept); // do not localize
    NonUTF8SetWindowText   := HookUser32Func('SetWindowTextA', @SetWindowTextAIntercept); // do not localize
    NonUTF8GetClassInfo    := HookUser32Func('GetClassInfoA', @GetClassInfoAIntercept); // do not localize
    NonUTF8GetClassInfoEx  := HookUser32Func('GetClassInfoExA', @GetClassInfoExAIntercept); // do not localize
    NonUTF8CallWindowProc  := HookUser32Func('CallWindowProcA', @CallWindowProcAIntercept); // do not localize
    NonUTF8IsWindowUnicode := HookUser32Func('IsWindowUnicode', @IsWindowUnicodeIntercept); // do not localize
    NonUTF8GetWindowLong   := HookUser32Func('GetWindowLongA', @GetWindowLongAIntercept); // do not localize

    NonUTF8DefWindowProc   := HookUser32Func('DefWindowProcA', @DefWindowProcAIntercept); // do not localize
    NonUTF8DefMDIChildProc := HookUser32Func('DefMDIChildProcA', @DefMDIChildProcAIntercept); // do not localize
    NonUTF8DefDlgProc      := HookUser32Func('DefDlgProcA', @DefDlgProcAIntercept); // do not localize
    NonUTF8DefFrameProc    := HookUser32Func('DefFrameProcA', @DefFrameProcAIntercept); // do not localize

    NonUTF8GetWindowText  := HookUser32Func('GetWindowTextA', @GetWindowTextAIntercept); // do not localize
    NonUTF8InsertMenu     := HookUser32Func('InsertMenuA', @InsertMenuAIntercept); // do not localize
    NonUTF8InsertMenuItem := HookUser32Func('InsertMenuItemA', @InsertMenuItemAIntercept); // do not localize
    NonUTF8MessageBox     := HookUser32Func('MessageBoxA', @MessageBoxAIntercept); // do not localize

    NonUTF8TextOut              := HookGdi32Func('TextOutA', @TextOutAIntercept); // do not localize
    NonUTF8ExtTextOut           := HookGdi32Func('ExtTextOutA', @ExtTextOutAIntercept); // do not localize
    NonUTF8GetTextExtentPoint32 := HookGdi32Func('GetTextExtentPoint32A', @GetTextExtentPoint32AIntercept); // do not localize
    NonUTF8GetTextExtentPoint   := HookGdi32Func('GetTextExtentPointA', @GetTextExtentPointAIntercept); // do not localize
    NonUTF8GetTextExtentExPoint := HookGdi32Func('GetTextExtentExPointA', @GetTextExtentExPointAIntercept); // do not localize

    NonUTF8OutputDebugString := HookKernel32Func('OutputDebugStringA', @OutputDebugStringAIntercept); // do not localize
    NonUTF8FatalAppExit      := HookKernel32Func('FatalAppExitA', @FatalAppExitAIntercept); // do not localize

    NonUTF8GetOpenFileName := HookCommdlg32Func('GetOpenFileNameA', @GetOpenFileNameAIntercept); // do not localize
    NonUTF8GetSaveFileName := HookCommdlg32Func('GetSaveFileNameA', @GetSaveFileNameAIntercept); // do not localize
    NonUTF8GetFileTitle    := HookCommdlg32Func('GetFileTitleA', @GetFileTitleAIntercept); // do not localize
    NonUTF8ChooseColor     := HookCommdlg32Func('ChooseColorA', @ChooseColorAIntercept); // do not localize
  end
  else
  begin
    // TODO unhooking
  end;
end;

initialization
  NonUTF8DefaultSystemCodePage := GetACP;
  ActivateUtf8VCL(True);

{$IFDEF CONDITIONALEXPRESSIONS}
  {$IF CompilerVersion >= 18.0}
    // System does this GetACP before we can do the patching, so we fix this now. introduced in bds2006
  SetMultiByteConversionCodePage(GetACP);
  {$IFEND}
{$ENDIF}

end.

