{**************************************************************************************************}
{                                                                                                  }
{ UTF-8 VCL                                                                                        }
{                                                                                                  }
{ The contents of this file are subject to the Mozilla Public License Version 1.1 (the "License"); }
{ you may not use this file except in compliance with the License. You may obtain a copy of the    }
{ License at http://www.mozilla.org/MPL/                                                           }
{                                                                                                  }
{ Software distributed under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF   }
{ ANY KIND, either express or implied. See the License for the specific language governing rights  }
{ and limitations under the License.                                                               }
{                                                                                                  }
{ The Original Code is UTF8VCLControls.pas                                                         }
{                                                                                                  }
{ The Initial Developer of the Original Code is Bart van der Werf (bwerf, bluelive)                }
{ Portions created by Bart van der Werf are Copyright (C) Bart van der Werf. All rights reserved.  }
{                                                                                                  }
{ Contributor(s):                                                                                  }
{   Andreas Hausladen (ahuser)                                                                     }
{   Robert Marquardt (rom, marquardt)                                                              }
{                                                                                                  }
{**************************************************************************************************}

// Last modified: $Date: 2007/03/28 14:22:33 $

unit UTF8VCLControls;

interface

uses
  Forms, Controls, Messages;

procedure HookTWinControlDoKeyPress;

implementation

uses
  UTF8VCLUtils;

type
  TWinControlPatch = class(TWinControl)
  private
    procedure HookTWinControlDoKeyPress;
    function DoKeyPressPatch(var Mesg: TWMKey): Boolean;
  end;

procedure HookTWinControlDoKeyPress;
begin
  TWinControlPatch(nil).HookTWinControlDoKeyPress;
end;

function TWinControlPatch.DoKeyPressPatch(var Mesg: TWMKey): Boolean;
var
  Form: TCustomForm;
  Ch: Char;
begin
  Result := True;
  Form := GetParentForm(Self);
  if (Form <> nil) and (Form <> TWinControl(Self)) and Form.KeyPreview and
    TWinControlPatch(Form).DoKeyPress(Mesg) then
    Exit;
  if not (csNoStdEvents in ControlStyle) then
    with Mesg do
    begin
      if CharCode < 256 then
      begin
        Ch := Char(CharCode);
        KeyPress(Ch);
        CharCode := Word(Ch);
        if Char(CharCode) = #0 then
          Exit;
      end;
    end;
  Result := False;
end;

procedure TWinControlPatch.HookTWinControlDoKeyPress;
type
  TWMKeyProc = function(var Message: TWMKey): Boolean of object;
var
  A, B: TWMKeyProc;
begin
  A := DoKeyPress;
  B := DoKeyPressPatch;
  InjectJumpHook(TMethod(A).Code, TMethod(B).Code);
end;

initialization
  HookTWinControlDoKeyPress;

end.

